<?php
//
// +----------------------------------------------------------------------+
// |zen-cart Open Source E-commerce                                       |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 The zen-cart developers                           |
// |                                                                      |
// | http://www.zen-cart.com/index.php                                    |
// |                                                                      |
// | Portions Copyright (c) 2003 osCommerce                               |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.0 of the GPL license,       |
// | that is bundled with this package in the file LICENSE, and is        |
// | available through the world-wide-web at the following url:           |
// | http://www.zen-cart.com/license/2_0.txt.                             |
// | If you did not receive a copy of the zen-cart license and are unable |
// | to obtain it through the world-wide-web, please send a note to       |
// | license@zen-cart.com so we can mail you a copy immediately.          |
// +----------------------------------------------------------------------+
// $Id: ot_local_sales_taxes.php v1.1
//

global $ot_local_sales_taxes_rate_description, $ot_local_sales_taxes_charge_tax_on_shipping, $ot_local_sales_taxes_basis;



// ------------------ BEGIN USER CONFIGURATION SECTION -------------------- //

// text used to describe the tax on the invoice
//$ot_local_sales_taxes_rate_description = "Local Sales Tax - ";

// set to true/false to determine if the tax is assessed on the shipping fee as well as the subtotal of the items
//LocalSalesTax Mod Tax on shipping now built into mod
//$ot_local_sales_taxes_charge_tax_on_shipping = false;

//tax basis determined in admin -> My Store -> "Product Tax"
//you can override this option by changing to either "Billing" or "Shipping"
$ot_local_sales_taxes_basis = STORE_PRODUCT_TAX_BASIS;

// ------------------ END USER CONFIGURATION SECTION -------------------- //


  class ot_local_sales_taxes {
    var $title, $output;

    function ot_local_sales_taxes() {
      $this->code = 'ot_local_sales_taxes';
      $this->title = MODULE_ORDER_TOTAL_COUNTY_LOCAL_TAX_TITLE;
      $this->description = MODULE_ORDER_TOTAL_COUNTY_LOCAL_TAX_DESCRIPTION;
      $this->sort_order = MODULE_ORDER_TOTAL_COUNTY_LOCAL_TAX_SORT_ORDER;

      $this->output = array();
    }

    function process() {
        global $order;
      global $db;

        global $ot_local_sales_taxes_rate, $ot_local_sales_taxes_rate_description, $ot_local_sales_taxes_charge_tax_on_shipping, $ot_local_sales_taxes_basis;

				//check cart settings to see if we are looking at billing or shipping data
				 if ($ot_local_sales_taxes_basis == 'Billing') {
            $ot_local_sales_taxes_zoneid = $order->billing['zone_id'];
          } elseif ($ot_local_sales_taxes_basis == 'Shipping') {
            	$ot_local_sales_taxes_zoneid = $order->delivery['zone_id'];
          } else {
            if (STORE_ZONE == $order->billing['zone_id']) {
              $ot_local_sales_taxes_zoneid = $order->billing['zone_id'];
            } else {
              $ot_local_sales_taxes_zoneid = $order->delivery['zone_id']; 
            } 
						}
						//echo $ot_local_sales_taxes_basis;
						//echo $ot_local_sales_taxes_zoneid;
						$taxsql = "select local_tax_id, zone_id, local_fieldmatch, local_datamatch, local_tax_rate, local_tax_label, local_tax_shipping from " . TABLE_LOCAL_SALES_TAXES . " where zone_id =  '" . $ot_local_sales_taxes_zoneid . "'";
						
				 		//get tax rates for field lookup
				 			 $taxResult = $db->Execute($taxsql);
							 //If a tax was found, then apply it.
							 if ($taxResult->RecordCount()>0){//Check to see if it was null and not found.
							 //echo "got one!";
							 while (!$taxResult->EOF) {
							 		$ot_local_sales_taxes_rate_description = "";
							 		$taxto = $taxResult->fields['local_datamatch'];
				 			 		$taxmatch = $taxResult->fields['local_fieldmatch'];
									$taxshipping = $taxResult->fields['local_tax_shipping'];
									
									//$myfield = $order->delivery[$taxmatch];
									//check cart settings to see if we match to billing or shipping address
													 if ($ot_local_sales_taxes_basis == 'Billing') {
            							 		$myfield = $order->billing[$taxmatch];
          										} elseif ($ot_local_sales_taxes_basis == 'Shipping') {
            									$myfield = $order->delivery[$taxmatch];            									
															}else{ 
															if (STORE_ZONE == $order->billing['zone_id']) {
              								 $myfield = $order->billing[$taxmatch];
            									 } else {
              								 $myfield = $order->delivery[$taxmatch]; 
            									 } 
															}
									
				 			 		
          		 if ($myfield == $taxto) {
							 //echo "here it is";
							 //get sales taxes that apply to this local lookup
							 					$taxlabel =  $taxResult->fields['local_tax_label'];		 
							 				 //next we define the text used to describe the tax on the invoice 
				 							 //to use only the rule label uncomment the following
											 $ot_local_sales_taxes_rate_description = $ot_local_sales_taxes_rate_description . " " .$myfield;
											 //to see the specific tax area with label uncomment the follwing
											 $ot_local_sales_taxes_rate_description = $ot_local_sales_taxes_rate_description . " " . $taxlabel;
											 
								//do we tax shipping for this localcality
									
									if($taxshipping == "true"){
									//echo "tax on shipping " . $taxshipping ;
									$ot_local_sales_taxes_charge_tax_on_shipping = true;
									}else{
									//echo "no tax on shipping " . $taxshipping;
									$ot_local_sales_taxes_charge_tax_on_shipping = false;
									}
							 
							 $taxRateLocal = $taxResult->fields['local_tax_rate']; 
							 $taxRate = $taxRateLocal;
							 $LocalTaxTotal = $LocalTaxTotal + ($order->info['subtotal'] * $taxRateLocal/100);
							 $taxName = $ot_local_sales_taxes_rate_description . " " . ((double)$taxRate) .'%';
							
						$order->info['Tax'] = ($order->info['subtotal'] + ($order->info['shipping_cost'] * (int) $ot_local_sales_taxes_charge_tax_on_shipping)) * ($taxRate / 100);
						$order->info['tax_groups'] += array($taxName => $order->info['Tax']);
            $order->info['total'] = $order->info['shipping_cost'] + $order->info['subtotal'] + $order->info['tax'] + $LocalTaxTotal;
						   }
          		 $taxResult->MoveNext();
        			 }
         } //else {
            //echo 'Tax rate was not found.  No county defined.';
         //}
         //echo ' -->';
      }

    function check() {
     global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_ORDER_TOTAL_COUNTY_LOCAL_TAX_STATUS'");
        $this->_check = $check_query->RecordCount();
      }

      return $this->_check;
    }

    function keys() {
      return array('MODULE_ORDER_TOTAL_COUNTY_LOCAL_TAX_STATUS', 'MODULE_ORDER_TOTAL_COUNTY_LOCAL_TAX_SORT_ORDER');
    }

    function install() {
     global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('This module is installed', 'MODULE_ORDER_TOTAL_COUNTY_LOCAL_TAX_STATUS', 'true', '', '6', '1','zen_cfg_select_option(array(\'true\'), ', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_ORDER_TOTAL_COUNTY_LOCAL_TAX_SORT_ORDER', '250', 'Sort order of display.', '6', '2', now())");
    }

    function remove() {
     global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }
  }
?>
